/*
  HTTP Request 1.0.5.50
  Author: Drew Phillips
  Site:   www.neoprogrammers.com

  This code is released freely in hopes that it will help someone learn about
  programming in c with windows api and winsock.  It has no warranty and the
  author cannot be held responsible for any problems it may cause.  There is
  absolutely no guarantee it will work.  May not be released without this comment
  or due credit in any subsequent modifications.
 */

#include <windows.h>
#include <commctrl.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "resource.h"

#pragma comment(lib, "WS2_32.LIB")
#pragma comment(lib, "comctl32.lib")

#define SBUFFER_SIZE  256
#define LSBUFFER_SIZE 4096


#define IDC_LIST   9999


DWORD CALLBACK doRequest(LPVOID);
void           clearAll (HWND);
void           urlEncode(HWND);
char           *nl2crlf(char *buf);


//Main Window Message Handler
BOOL
CALLBACK
MainProc(HWND hWnd, 
		 UINT Message,
		 WPARAM wParam,
		 LPARAM lParam)
{
	switch(Message)
	{
		case WM_INITDIALOG: {
			HFONT hfDefault = GetStockObject(DEFAULT_GUI_FONT);
			HWND combo = CreateWindowEx(0, "ComboBox", NULL, WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_VSCROLL | WS_TABSTOP | CBS_DROPDOWNLIST, 90, 61, 80, 130, hWnd, (HMENU)IDC_LIST, GetModuleHandle(NULL), 0);
			INITCOMMONCONTROLSEX ic;

			ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
			ic.dwICC  = ICC_WIN95_CLASSES;

			InitCommonControlsEx(&ic);

			SetWindowPos(combo, GetDlgItem(hWnd, IDC_FILE), 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

			SendMessage(hWnd, WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, SM_CXICON, SM_CYICON, LR_DEFAULTCOLOR));

			SetDlgItemText(hWnd, IDC_HOST, "www.example.com\0");
			SetDlgItemText(hWnd, IDC_PORT, "80\0");
			SetDlgItemText(hWnd, IDC_FILE, "/\0");


			SendMessage(combo, WM_SETFONT, (WPARAM)hfDefault, MAKELPARAM(FALSE, 0));
			SendMessage(combo, CB_ADDSTRING, 0, (LPARAM)"GET\0");
			SendMessage(combo, CB_ADDSTRING, 0, (LPARAM)"POST\0");
			SendMessage(combo, CB_ADDSTRING, 0, (LPARAM)"HEAD\0");
			SendMessage(combo, CB_SETCURSEL, (WPARAM)0, 0);

			break;
		}

		case WM_CLOSE:
			EndDialog(hWnd, 0);
			break;

		default:
			return FALSE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_RESET_COMMAND:
					clearAll(hWnd);
					break;

				case IDC_REQUEST_COMMAND:
				{
					//doRequest(hWnd);
					HANDLE thread = CreateThread(NULL, 0, doRequest, (LPVOID)hWnd, 0, NULL);
					CloseHandle(thread);
					break;
				}
			}

			switch(HIWORD(wParam))
			{
				case CBN_SELCHANGE:
				{
					char val[5];
					int length = SendMessage(GetDlgItem(hWnd, IDC_LIST), CB_GETCURSEL, 0, 0);
					SendMessage(GetDlgItem(hWnd, IDC_LIST), CB_GETLBTEXT, (WPARAM)length, (LPARAM)val);
					if (strcmp(val, "POST\0") == 0) {
						EnableWindow(GetDlgItem(hWnd, IDC_POSTDATA), TRUE);
					} else {
						EnableWindow(GetDlgItem(hWnd, IDC_POSTDATA), FALSE);
					}
					break;
				}

				case EN_KILLFOCUS:
					switch(LOWORD(wParam))
					{
						case IDC_POSTDATA:
							urlEncode(GetDlgItem(hWnd, IDC_POSTDATA));
							break;
					}
					break;
			}
			break;
	}
	return TRUE;
}


int
WINAPI
WinMain(HINSTANCE hInstance,
		HINSTANCE hPrevInstance,
		LPSTR lpCmdLine,
		int nCmdShow)
{
	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainProc);
}


DWORD
CALLBACK
doRequest(LPVOID lpParam)
{
	WSADATA            wsaData;
	SOCKET             sock;
	struct hostent     *target;
	struct sockaddr_in sin;

	int    length;/*
	char   *host    = (char*)malloc(SBUFFER_SIZE);
	char   *portnum = (char*)malloc(5);
	char   *file    = (char*)malloc(SBUFFER_SIZE);
	char   *mesg    = (char*)malloc(LSBUFFER_SIZE);
	char   *headers = (char*)malloc(LSBUFFER_SIZE*2);
	char   *poststr = (char*)malloc(LSBUFFER_SIZE);
	char   *sendstr = (char*)malloc(LSBUFFER_SIZE*2);*/

	//08/02/2005 did away with static allocation, more efficient allocating real size
	char *host = NULL;
	char portnum[4];
	char *file = NULL;
	char mesg[SBUFFER_SIZE];
	char *headers = NULL;
	char *poststr = NULL;
	char sendstr[LSBUFFER_SIZE];

	char   method[4];
	USHORT port;

	char  *recvstr = (char*)malloc(1);
	char  recvbuf[SBUFFER_SIZE];
	int   bytes    = 0;
	long  bytesReceived = 0;

	char *resp_body = NULL;
	char *resp_head = NULL;
	char *fixnewlines = NULL;

	HWND mainhwnd = (HWND)lpParam;


	EnableWindow(GetDlgItem(mainhwnd, IDC_REQUEST_COMMAND), FALSE);

	SendMessage(GetDlgItem(mainhwnd, IDC_RESPONSEHEADERS), WM_SETTEXT, 0, (LPARAM)"\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_HTTPRESPONSE), WM_SETTEXT, 0, (LPARAM)"\0");

	length = SendMessage(GetDlgItem(mainhwnd, IDC_HOST), WM_GETTEXTLENGTH, 0, 0);
	if (length == 0) {
		MessageBox(mainhwnd, "You must specify a target host!", "Error", MB_OK | MB_ICONERROR);
		goto free2;
	} else {
		host = (char*)malloc(length+1);
		SendMessage(GetDlgItem(mainhwnd, IDC_HOST), WM_GETTEXT, (WPARAM)length+1, (LPARAM)host);
	}

	length = SendMessage(GetDlgItem(mainhwnd, IDC_PORT), WM_GETTEXTLENGTH, 0, 0);
	if (length == 0) {
		MessageBox(mainhwnd, "You must specify a target port!", "Error", MB_OK | MB_ICONERROR);
		goto free2;
	}

	length = SendMessage(GetDlgItem(mainhwnd, IDC_FILE), WM_GETTEXTLENGTH, 0, 0);
	if (length == 0) {
		MessageBox(mainhwnd, "You must specify a remote file!", "Error", MB_OK | MB_ICONERROR);
		goto free2;
	} else {
		file = (char*)malloc(length+1);
		SendMessage(GetDlgItem(mainhwnd, IDC_FILE), WM_GETTEXT, (WPARAM)length+1, (LPARAM)file);
	}

	length = SendMessage(GetDlgItem(mainhwnd, IDC_HEADERS), WM_GETTEXTLENGTH, 0, 0);
	if (length > 0) {
		headers = (char*)malloc(length+3);
		SendMessage(GetDlgItem(mainhwnd, IDC_HEADERS), WM_GETTEXT, (LPARAM)length+3, (WPARAM)headers);
		strcat(headers, "\r\n");
	} else {
		headers = (char*)malloc(2);
		strcpy(headers, "");
	}


	if (WSAStartup(MAKEWORD(2, 2), &wsaData) < 0) {
		MessageBox(mainhwnd, "Error: Your winsock version is too old!", "Error", MB_OK | MB_ICONERROR);
		goto free2;
	}

	SetWindowText(GetDlgItem(mainhwnd, IDC_SOCKETSTATUS), "Creating Socket...");

	sock = socket(PF_INET, SOCK_STREAM, 0);
	if (sock == INVALID_SOCKET) {
		MessageBox(mainhwnd, "Unable to create communication socket!", "Error", MB_OK | MB_ICONERROR);
		goto free;
	}


	
	target = gethostbyname(host);

	if (target == NULL) {
		MessageBox(mainhwnd, "Unable to resolve host!", "Error", MB_OK | MB_ICONERROR);
		goto free;
	}

	SendMessage(GetDlgItem(mainhwnd, IDC_PORT), WM_GETTEXT, (WPARAM)5, (LPARAM)portnum);
	port = (USHORT)atoi(portnum);

	

	memcpy(&sin.sin_addr.s_addr, target->h_addr_list[0], target->h_length);
	sin.sin_family = AF_INET;
	sin.sin_port   = htons(port);

	SetWindowText(GetDlgItem(mainhwnd, IDC_SOCKETSTATUS), "Connecting to host...");


	if (connect(sock, (struct sockaddr *)&sin, sizeof(sin))) {
		MessageBox(mainhwnd, "Unable to connect to server!", "Error", MB_OK | MB_ICONERROR);
		goto free;
	}

	//make request string
	length = SendMessage(GetDlgItem(mainhwnd, IDC_LIST), CB_GETCURSEL, 0, 0);
	SendMessage(GetDlgItem(mainhwnd, IDC_LIST), CB_GETLBTEXT, (WPARAM)length, (LPARAM)method);

	if (strcmp(method, "POST\0") == 0) {
		length = SendMessage(GetDlgItem(mainhwnd, IDC_POSTDATA), WM_GETTEXTLENGTH, 0, 0);

		sprintf(mesg,
			    "Content-Type: application/x-www-form-urlencoded\r\nContent-Length: %d\r\n",
				length);
		
		headers = (char*)realloc(headers, strlen(headers) + strlen(mesg) + 1);
		strcat(headers, mesg);

		length = SendMessage(GetDlgItem(mainhwnd, IDC_POSTDATA), WM_GETTEXTLENGTH, 0, 0);
		poststr = (char*)malloc(length+3);
		SendMessage(GetDlgItem(mainhwnd, IDC_POSTDATA), WM_GETTEXT, (WPARAM)length+3, (LPARAM)poststr);
		strcat(poststr, "\r\n");
	} else {
		poststr = (char*)malloc(2);
		strcpy(poststr, "");
	}

	sprintf(sendstr, "%s %s HTTP/1.0\r\nHost: %s\r\nConnection: close\r\n%s\r\n%s",
		    method,
			file,
			host,
			headers,
			poststr);

	SetWindowText(GetDlgItem(mainhwnd, IDC_FINALREQUEST), sendstr);
	SetWindowText(GetDlgItem(mainhwnd, IDC_SOCKETSTATUS), "Sending Request");

	if (send(sock, sendstr, strlen(sendstr), 0) == -1) {
		MessageBox(mainhwnd, "Failed to send HTTP request!", "Error", MB_OK | MB_ICONERROR);
		goto free;
	}

	strcpy(recvstr, "");
	while ( (bytes = recv(sock, recvbuf, SBUFFER_SIZE, 0)) > 0) {
		bytesReceived += bytes;
		sprintf(mesg, "Received %d bytes", bytesReceived);
		SetWindowText(GetDlgItem(mainhwnd, IDC_SOCKETSTATUS), mesg);

		recvstr = (char*)realloc(recvstr, strlen(recvstr) + bytes + 1);
		if (recvstr == NULL) {
			MessageBox(mainhwnd, "Unable to allocate more memory for receive buffer!", "Error", MB_OK | MB_ICONERROR);
			goto free;
		}
		strncat(recvstr, recvbuf, bytes);
	}
	
	if (strcmp(method, "HEAD\0") != 0) {		
		resp_body = strstr(recvstr, "\r\n\r\n") + 4;
		resp_head = (char*)malloc(resp_body - recvstr + 1);
		strcpy(resp_head, "");
		strncat(resp_head, recvstr, (resp_body - recvstr) - 4);

		fixnewlines = nl2crlf(resp_body);

		SendMessage(GetDlgItem(mainhwnd, IDC_RESPONSEHEADERS), WM_SETTEXT, 0, (LPARAM)resp_head);
		SendMessage(GetDlgItem(mainhwnd, IDC_HTTPRESPONSE), WM_SETTEXT, 0, (LPARAM)fixnewlines);
	} else {
		SendMessage(GetDlgItem(mainhwnd, IDC_RESPONSEHEADERS), WM_SETTEXT, 0, (LPARAM)recvstr);
	}


	SetWindowText(GetDlgItem(mainhwnd, IDC_SOCKETSTATUS), "Closing Connection");
free:
	closesocket(sock);
	WSACleanup();
free2:
	free(host);
	free(portnum);
	free(file);
	free(resp_head);
	//free(resp_body);
	free(sendstr);
	//free(headers);
	free(poststr);
	free(recvstr);
	free(mesg);
	free(fixnewlines);

	SetWindowText(GetDlgItem(mainhwnd, IDC_SOCKETSTATUS), "Not Connected");
	EnableWindow(GetDlgItem(mainhwnd, IDC_REQUEST_COMMAND), TRUE);


	return 0;
}


void
clearAll(HWND mainhwnd)
{
	SendMessage(GetDlgItem(mainhwnd, IDC_FINALREQUEST), WM_SETTEXT, 0, (LPARAM)"\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_HEADERS), WM_SETTEXT, 0, (LPARAM)"\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_HTTPRESPONSE), WM_SETTEXT, 0, (LPARAM)"\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_RESPONSEHEADERS), WM_SETTEXT, 0, (LPARAM)"\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_HOST), WM_SETTEXT, 0, (LPARAM)"www.example.com\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_PORT), WM_SETTEXT, 0, (LPARAM)"80\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_FILE), WM_SETTEXT, 0, (LPARAM)"/\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_POSTDATA), WM_SETTEXT, 0, (LPARAM)"\0");
	SendMessage(GetDlgItem(mainhwnd, IDC_LIST), CB_SETCURSEL, (WPARAM)0, 0);
	EnableWindow(GetDlgItem(mainhwnd, IDC_POSTDATA), FALSE);
}


void
urlEncode(HWND handle)
{
	int  length;
	char *text;
	char *encoded = (char*)malloc(LSBUFFER_SIZE);
	int  i;
	char *x = (char*)malloc(1);

	length = SendMessage(handle, WM_GETTEXTLENGTH, 0, 0);
	text   = (char*)malloc(length+1);

	SendMessage(handle, WM_GETTEXT, (WPARAM)length+1, (LPARAM)text);

	strcpy(encoded, "");

	for (i = 0; i < length; ++i) {
		switch(text[i]) {
			case ' ': strcat(encoded, "+"); break;
			case '?': strcat(encoded, "%3F"); break;
			case '!': strcat(encoded, "%21"); break;
			case '@': strcat(encoded, "%40"); break;
			case '#': strcat(encoded, "%23"); break;
			case '$': strcat(encoded, "%24"); break;
			//case '%': strcat(encoded, "%25"); break;
			case '^': strcat(encoded, "%5E"); break;
			//case '&': strcat(encoded, "%26"); break;
			case '*': strcat(encoded, "%2A"); break;
			case '(': strcat(encoded, "%28"); break;
			case ')': strcat(encoded, "%29"); break;
			case '+': strcat(encoded, "%2B"); break;
			case '`': strcat(encoded, "%60"); break;
			case '~': strcat(encoded, "%7E"); break;
			case ',': strcat(encoded, "%2C"); break;
			case '/': strcat(encoded, "%2F"); break;
			case '<': strcat(encoded, "%3C"); break;
			case '>': strcat(encoded, "%3E"); break;
			case '[': strcat(encoded, "%5B"); break;
			case ']': strcat(encoded, "%5D"); break;
			case '\\': strcat(encoded, "%5C"); break;
			case '{': strcat(encoded, "%7B"); break;
			case '}': strcat(encoded, "%7D"); break;
			case '|': strcat(encoded, "%7C"); break;
			case ';': strcat(encoded, "%3B"); break;
			case ':': strcat(encoded, "%3A"); break;
			case '"': strcat(encoded, "%22"); break;
			case '\'': strcat(encoded, "%27"); break;
			default:  sprintf(x, "%c", text[i]); strcat(encoded, x);
		}
	}

	SendMessage(handle, WM_SETTEXT, 0, (LPARAM)encoded);
	free(encoded);
	free(text);
	free(x);
}


char *nl2crlf(char *s)
{
	int size_of_s;
	int match = 0, i, j;
	int size_of_buffer;
	char *buffer;

	if(s == NULL) return NULL;

	size_of_s = strlen(s);
	if(size_of_s == 0) return NULL; // Verify if any string is a 0 byte string, we handle this by return NULL

	for(i = 0; i < size_of_s; ++i) if(s[i] == '\n' && s[i-1] != '\r') ++match; // Increment the count.
	if(match == 0) {
		buffer = (char*)malloc(size_of_s + 1);
		strcpy(buffer, s);
		return buffer; // string doesnt need to be change but we copy this for the sake of the other code.
	}

	size_of_buffer = size_of_s - match + 2 * match; // Calculate the new size for the string.

	buffer = (char*)malloc(size_of_buffer + 1); // Allocate the memory we need for the new string.
	if(buffer == NULL) return NULL; // We are on memory shortage...

	for(i = 0, j = 0; i < size_of_s; i++, j++)
	{
		if(s[i] == '\n' && s[i-1] != '\r')
		{
			buffer[j] = '\r';
			j++;
			buffer[j] = '\n';
		}
		else buffer[j] = s[i];
	}

	buffer[j] = '\0'; // Terminate the string.
	return buffer; // You should call delete to free this string when your done with it...
}

